//$Id: MessageDialog.java,v 1.2 2007/05/22 20:55:41 Sasha Buzko Exp $
//
//Copyright (c) 2000-2003 San Diego Supercomputer Center (SDSC),
//a facility operated jointly by the University of California,
//San Diego (UCSD) and General Atomics, San Diego, California, USA.
//
//Users and possessors of this source code are hereby granted a
//nonexclusive, royalty-free copyright and design patent license to
//use this code in individual software. License is not granted for
//commercial resale, in whole or in part, without prior written
//permission from SDSC. This source is provided "AS IS" without express
//or implied warranty of any kind.
// 
//For further information, please see: <http://mbt.sdsc.edu>
// 
//History:
//$Log: MessageDialog.java,v $
//Revision 1.2  2007/05/22 20:55:41  Sasha Buzko
//*** empty log message ***
//
//Revision 1.1  2006/10/21 17:52:13  Sasha Buzko
//Refactored the project to move all new code to edu.sdsc.sirius package.
//
//Revision 1.1  2006/05/20 17:02:01  Sasha Buzko
//Updated version
//
//Revision 1.1  2006/04/30 20:13:56  Sasha Buzko
//New version of the app
//
//Revision 1.1  2006/04/15 19:42:18  Sasha Buzko
//Initial commit
//
//Revision 1.1  2005/11/13 04:35:23  Administrator
//*** empty log message ***
//
//Revision 1.2 2003/05/15 23:44:54 moreland
//Cleaned up code a bit for a preliminary release to obuzko.
//
//Revision 1.1 2003/05/15 22:42:45 moreland
//An application which incorporates more MBT GUI layer components.
//
//Revision 1.0 2003/05/05 16:06:13 moreland
//First version.
// 

package edu.sdsc.sirius.dialogs;

import javax.swing.*;
import java.awt.event.*;
import javax.swing.border.*;
import java.awt.*;

public class MessageDialog extends JDialog {

//  Add for internationalization
	Locale locale;
	private ResourceBundle reslang;
	reslang = ResourceBundle.getBundle("SiriusLangRes", locale);
	private String[] _M_Symbol = new String[10];
// end
	
	private JFrame parent = null;
	private JDialog parentDialog = null;
	private String message = null;
	
	private Container contentPane = null;
	private JScrollPane scrollPane = null;
	private JTextPane textPane = null;
	
	public MessageDialog(JFrame parent, String message){
		
// 		super(parent, "Explorer message", true);
_M_Symbol[0] = (String)reslang.getObject("M_Explorermessage")
		super(parent, _M_Symbol[0], true);
		this.parent = parent;
		this.message = message;
		
		initialize();
	}
	
	public MessageDialog(JFrame parent, String message, String title){
		
		super(parent, title, true);
		this.parent = parent;
		this.message = message;
		
		initialize();
	}

	
	public MessageDialog(JDialog parent, String message){
		
// 		super(parent, "Explorer message", true);
_M_Symbol[0] = (String)reslang.getObject("M_Explorermessage")
		super(parent, _M_Symbol[0], true);
		this.parentDialog = parent;
		this.message = message;
		
		initialize();
	}
	
	private void initialize(){
		
		contentPane = getContentPane();
		
		JPanel base = new JPanel();
		base.setLayout(new BorderLayout());
		
		JPanel messagePanel = new JPanel();
		messagePanel.setLayout(new BorderLayout());
		messagePanel.setBorder(new BevelBorder(BevelBorder.LOWERED));
		
		textPane = new JTextPane();
		textPane.setSelectionColor(new Color(0,50,190));
		textPane.setBackground(new Color(210,210,210));
		textPane.setEditable(false);
		textPane.setText(message);
		textPane.setFont(new Font("Courier", Font.PLAIN, 12));
		
		scrollPane = new JScrollPane();
		JViewport vp = scrollPane.getViewport();
		vp.setView(textPane);
		
		messagePanel.add(scrollPane, BorderLayout.CENTER);
		
		JPanel buttonPanel = new JPanel();
		
		JButton button = new JButton("OK");
		button.setPreferredSize(new Dimension(70,25));
		button.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
				setVisible(false);
				dispose();
			}
		});
		buttonPanel.add(button);
		
		base.add(messagePanel, BorderLayout.CENTER);
		base.add(buttonPanel, BorderLayout.SOUTH);
		
		contentPane.add(base);
		
		setSize(400,450);
		
		if (parent == null && parentDialog == null){
			setLocationRelativeTo(null);
		}
		else if (parent != null){
			//set location
			Dimension d1 = getSize();
			Dimension d2 = parent.getSize();
		
			int x = Math.max((d2.width - d1.width)/2, 0);
			int y = Math.max((d2.height - d1.height)/2, 0);
		
			setBounds(x + parent.getX(), y + parent.getY(), d1.width, d1.height);
		}
		else if (parentDialog != null){
			//set location
			Dimension d1 = getSize();
			Dimension d2 = parentDialog.getSize();
		
			int x = Math.max((d2.width - d1.width)/2, 0);
			int y = Math.max((d2.height - d1.height)/2, 0);
		
			setBounds(x + parentDialog.getX(), y + parentDialog.getY(), d1.width, d1.height);
		}
		else{
			setLocationRelativeTo(null);
		}
		
		setVisible(true);
		
		
	}
	
	public static void main(String[] args){
		MessageDialog d = new MessageDialog((JFrame)null, "Message");
	}
	
}
