package edu.sdsc.sirius.builder;

// Core
// GUI
import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.border.*;

// MBT
import edu.sdsc.mbt.*;
import edu.sdsc.sirius.dialogs.*;
import edu.sdsc.sirius.util.Manager;
import edu.sdsc.sirius.util.DialogLayout;
import edu.sdsc.sirius.viewers.*;

public class SaveFragmentDialog extends JDialog implements DisplayDialog {
//  Add for internationalization
	Locale locale;
	private ResourceBundle reslang;
	reslang = ResourceBundle.getBundle("SiriusLangRes", locale);
	private String[] _M_Symbol = new String[10];
// end
	private JFrame parentFrame;
	private Manager parent;
	private StructureViewer sv;
	private StructureComponent structureComponent;
	
	private DisplayDialog itself;

	private Container contentPane;
	private JPanel base = new JPanel();
	
	private JPanel topPanel = new JPanel();
	private JPanel namePanel = new JPanel();
	private JPanel attachPanel = new JPanel();
	
	private Border border1 = null;
	private TitledBorder border2 = null;
	private Border border = null;
	
	private JTextField objectField = new JTextField(50);
// 	private JLabel objectLabel = new JLabel("Pick the object in display:");
	private JLabel objectLabel = new JLabel(M_Picktheobjectindis);
	
	private JTextField nameField = new JTextField(70);
// 	private JLabel nameLabel = new JLabel("Enter fragment name:");
	private JLabel nameLabel = new JLabel(M_Enterfragmentname);
	
	private JTextField attach1 = new JTextField(50);
	private JTextField attach2 = new JTextField(50);
	private JTextField attach3 = new JTextField(50);
	private JTextField attach4 = new JTextField(50);
	private JTextField attach5 = new JTextField(50);
	
	private StructureComponent[] attachments = new StructureComponent[5];//structure components
	
	private JTextField currentField = objectField;
	
// 	private JLabel attachLabel1 = new JLabel("First attachment point:");
	private JLabel attachLabel1 = new JLabel(M_Firstattachmentpoi);
// 	private JLabel attachLabel2 = new JLabel("Second attachment point:");
	private JLabel attachLabel2 = new JLabel(M_Secondattachmentpo);
// 	private JLabel attachLabel3 = new JLabel("Third attachment point:");
	private JLabel attachLabel3 = new JLabel(M_Thirdattachmentpoi);
// 	private JLabel attachLabel4 = new JLabel("Fourth attachment point:");
	private JLabel attachLabel4 = new JLabel(M_Fourthattachmentpo);
// 	private JLabel attachLabel5 = new JLabel("Fifth attachment point:");
	private JLabel attachLabel5 = new JLabel(M_Fifthattachmentpoi);
	
	private JButton okButton = new JButton("OK");
// 	private JButton cancelButton = new JButton("Cancel");
	private JButton cancelButton = new JButton(M_Cancel);
	
	public SaveFragmentDialog(JFrame f, Manager p, StructureViewer s){

// 		super(f, " Save custom fragment ", false);
		super(f, M_Savecustomfragment, false);

		parentFrame = f;
		parent = p;
		sv = s;
		
		parent.setDisplayDialogStatus(true);
		
		itself = this;
		
		//create the panels
		contentPane = getContentPane();
		contentPane.setLayout(null);
		
		base.setPreferredSize(new Dimension(300, 290));
		base.setBorder(new BevelBorder(BevelBorder.RAISED));
		base.setLocation(new Point(5,5));
		base.setBounds(5, 5, 300, 290);
		base.setLayout(null);
		
		topPanel.setPreferredSize(new Dimension(290, 55));
		topPanel.setLocation(new Point(5,5));
		topPanel.setBounds(5,5,290,55);
		topPanel.setLayout(null);
		
		border1 = BorderFactory.createEmptyBorder(0,0,0,0);//left offset of the boxes in the box
// 		border2 = BorderFactory.createTitledBorder(new EtchedBorder(), " Object to save as a fragment ");
		border2 = BorderFactory.createTitledBorder(new EtchedBorder(), M_Objecttosaveasafra);
		border2.setTitleColor(Color.black);
// 		border2.setTitleFont(new Font("Dialog", 0, 11));
		border2.setTitleFont(new Font(M_Dialog, 0, 11));
		border = BorderFactory.createCompoundBorder(border1, border2);
		topPanel.setBorder(border);
		
		objectLabel.setPreferredSize(new Dimension(150, 20));
		objectLabel.setLocation(new Point(15,20));
		objectLabel.setBounds(15,20,150,20);
	
		objectField.setPreferredSize(new Dimension(100, 20));
		objectField.setLocation(new Point(170, 20));
		objectField.setBounds(170,20,100,20);
		objectField.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				objectField.requestFocus();
				currentField = objectField;
			}
		});
		
		topPanel.add(objectLabel);
		topPanel.add(objectField);
		
		base.add(topPanel);
		
		namePanel.setPreferredSize(new Dimension(290, 55));
		namePanel.setLocation(new Point(5,230));
		namePanel.setBounds(5,230,290,55);
		namePanel.setLayout(null);
		
		border1 = BorderFactory.createEmptyBorder(0,0,0,0);//left offset of the boxes in the box
// 		border2 = BorderFactory.createTitledBorder(new EtchedBorder(), " Name of the new fragment ");
		border2 = BorderFactory.createTitledBorder(new EtchedBorder(), M_Nameofthenewfragme);
		border2.setTitleColor(Color.black);
// 		border2.setTitleFont(new Font("Dialog", 0, 11));
		border2.setTitleFont(new Font(M_Dialog, 0, 11));
		border = BorderFactory.createCompoundBorder(border1, border2);
		namePanel.setBorder(border);
		
		
		nameLabel.setPreferredSize(new Dimension(130, 20));
		nameLabel.setLocation(new Point(15,20));
		nameLabel.setBounds(15,20,130,20);
	
		nameField.setPreferredSize(new Dimension(120, 20));
		nameField.setLocation(new Point(120, 20));
		nameField.setBounds(150,20,120,20);
		nameField.addKeyListener(new KeyAdapter(){
			public void keyPressed(KeyEvent e){
				if (e.getKeyCode() == KeyEvent.VK_ENTER){
					process();
				}
				else if (e.getKeyCode() == KeyEvent.VK_ESCAPE){
					setVisible(false);
					parent.setDisplayDialogStatus(false);
					dispose();
				}
			}
		});
		
		namePanel.add(nameLabel);
		namePanel.add(nameField);
		base.add(namePanel);
		
		
		//add attachment points panel
		JPanel attachmentPanel = new JPanel();
		attachmentPanel.setPreferredSize(new Dimension(290, 170));
		attachmentPanel.setBounds(5,60,290,170);
		attachmentPanel.setLayout(new BorderLayout());
		
		border1 = BorderFactory.createEmptyBorder(0,0,0,0);//left offset of the boxes in the box
// 		border2 = BorderFactory.createTitledBorder(new EtchedBorder(), " Alternative attachment points ");
		border2 = BorderFactory.createTitledBorder(new EtchedBorder(), M_Alternativeattachm);
		border2.setTitleColor(Color.black);
// 		border2.setTitleFont(new Font("Dialog", 0, 11));
		border2.setTitleFont(new Font(M_Dialog, 0, 11));
		border = BorderFactory.createCompoundBorder(border1, border2);
		attachmentPanel.setBorder(border);
		
		JPanel innerPanel = new JPanel();
		innerPanel.setPreferredSize(new Dimension(290, 170));
		innerPanel.setLocation(new Point(5,2));
		innerPanel.setBounds(5,120,290,170);
		
		innerPanel.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
		
		innerPanel.setLayout(new DialogLayout());
		innerPanel.add(attachLabel1);
		innerPanel.add(attach1);
		innerPanel.add(attachLabel2);
		innerPanel.add(attach2);
		innerPanel.add(attachLabel3);
		innerPanel.add(attach3);
		innerPanel.add(attachLabel4);
		innerPanel.add(attach4);
		innerPanel.add(attachLabel5);
		innerPanel.add(attach5);
		
		
		attachmentPanel.add(innerPanel, BorderLayout.CENTER);
	
		base.add(attachmentPanel);
		
		
		//buttons
		okButton.setPreferredSize(new Dimension(80,25));
		okButton.setLocation(new Point(65, 305));
		okButton.setBounds(65, 305, 80, 25);
		okButton.setVisible(true);
		okButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
				process();
			}
		});
		
		cancelButton.setPreferredSize(new Dimension(80,25));
		cancelButton.setLocation(new Point(160, 305));
		cancelButton.setBounds(160, 305, 80, 25);
		cancelButton.setVisible(true);
		cancelButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
				setVisible(false);
				parent.setDisplayDialogStatus(false);
				dispose();
			}
		});
		
		contentPane.add(base);
		contentPane.add(okButton);
		contentPane.add(cancelButton);
		
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				setVisible(false);
				parent.setDisplayDialogStatus(false);
				dispose();
			}
			
			public void windowDeactivated(WindowEvent e){
				toFront();
			}
		});
				
		setSize(315, 370);
		
		//add this to accommodate both applet and application cases
		if (parentFrame == null){
//			setLocationRelativeTo(null);
			setBounds(0, 0, getSize().width, getSize().height);
		}
		else{
		
			//set location
			Dimension d1 = getSize();
			Dimension d2 = parentFrame.getSize();
		
			int x = 5 + DialogConstants.toolbarWidth;
			int y = DialogConstants.level;
		
			setBounds(x + parentFrame.getX(), y + parentFrame.getY(), d1.width, d1.height);
		}

		setResizable(false);
		
		setVisible(true);
		


	}
	
	private void process(){
		
		//add error checking for selection bounds
		//eg., selection level is residue, but entered only structure name
		
		Thread runner = new Thread(){
			public void run(){
				
				if (objectField.getText().length() == 0 || structureComponent == null){
// 					parent.displayErrorMessage("Nothing selected. Please define the structure and try again");
					parent.displayErrorMessage(M_NothingselectedPle_1);
					cleanup();
					return;
				}

				if (structureComponent == null){
					//look into the text entry: the user may have typed in the name
					Object object = sv.labelToObject(objectField.getText());
					if (object == null){
// 						parent.displayErrorMessage("Entered label does not define a structure. Please define the target and try again");
						parent.displayErrorMessage(M_Enteredlabeldoesno_1);
						cleanup();
						return;
					}
					
				}
				
				//check whether attachment points are given
				boolean pass = false;
				for (int i = 0; i < attachments.length; i++){
					if (attachments[i] != null){
						pass = true;
						break;
					}
				}
				
				if (!pass){
// 					parent.displayErrorMessage("At least one attachment atom must be specified.");
					parent.displayErrorMessage(M_Atleastoneattachme);
					cleanup();
					return;
				}
				
				parent.setDisplayDialogStatus(false);
				
				
				
				//proceed with saving the fragment				
				sv.saveCustomFragment(structureComponent, nameField.getText(), attachments);
			}
		};
		runner.start();
		dispose();
	}
	
	private void cleanup(){
		setVisible(false);
		parent.setDisplayDialogStatus(false);
		dispose();
	}
	
	public void processPick(String data, StructureComponent structureComponent){
		if (data.length() > 0){
			this.structureComponent = structureComponent;
			if (currentField == objectField){
				objectField.setText(data);
				currentField = attach1;
				attach1.requestFocus();
			}
			else if (currentField == attach1){
				Atom a = (Atom)structureComponent;
				if (a.element != 1){
					cleanup();
// 					parent.displayErrorMessage("Attachment points must be hydrogen atoms");
					parent.displayErrorMessage(M_Attachmentpointsmu);
					return;
				}
				attach1.setText(data);
				attachments[0] = structureComponent;
				currentField = attach2;
			}
			else if (currentField == attach2){
				Atom a = (Atom)structureComponent;
				if (a.element != 1){
					cleanup();
// 					parent.displayErrorMessage("Attachment points must be hydrogen atoms");
					parent.displayErrorMessage(M_Attachmentpointsmu);
					return;
				}
				attach2.setText(data);
				attachments[1] = structureComponent;
				currentField = attach3;
				attach3.requestFocus();
			}
			else if (currentField == attach3){
				Atom a = (Atom)structureComponent;
				if (a.element != 1){
					cleanup();
// 					parent.displayErrorMessage("Attachment points must be hydrogen atoms");
					parent.displayErrorMessage(M_Attachmentpointsmu);
					return;
				}
				attach3.setText(data);
				attachments[2] = structureComponent;
				currentField = attach4;
				attach4.requestFocus();
			}
			else if (currentField == attach4){
				Atom a = (Atom)structureComponent;
				if (a.element != 1){
					cleanup();
// 					parent.displayErrorMessage("Attachment points must be hydrogen atoms");
					parent.displayErrorMessage(M_Attachmentpointsmu);
					return;
				}
				attach4.setText(data);
				attachments[3] = structureComponent;
				currentField = attach5;
				attach5.requestFocus();
			}
			else if (currentField == attach5){
				Atom a = (Atom)structureComponent;
				if (a.element != 1){
					cleanup();
// 					parent.displayErrorMessage("Attachment points must be hydrogen atoms");
					parent.displayErrorMessage(M_Attachmentpointsmu);
					return;
				}
				attach5.setText(data);
				attachments[4] = structureComponent;
				currentField = objectField;
				objectField.requestFocus();
			}
		}
		
		if (structureComponent == null){
			this.structureComponent = null;
			objectField.setText("");
		}
		
	}
	
	
}
